# The Process

This file contains some process notes for FerretDB Inc. engineers and long-term contributors.
If you are a community contributor, feel free to ignore all this!
We will do all that for you so you can focus on what is really interesting for you.

We encourage diversity between us as different points of view expand our vision and contribute to the project's success.

Keep guides short: we don't create rules; we automate.

## Pull requests

1. Pull request **title** should be accurate and descriptive as it is used in the generated changelog.
   It should not end with a dot.
   It should not mention the issue number but describe the fixed issue instead.
2. Pull request **description** typically just mentions the issue number like "Refs #123." or "Closes #456.".
   Do not use `https://github.com/org/repo/issue/123` even if it is rendered the same on GitHub.
   End sentences with a dot.
3. Commit messages (both titles and bodies) are not important and can be "WIP" or anything else.
   All commits are always squashed on merge by GitHub, so there is no need to squash them manually, amend them, and/or do force pushes.
   Autogenerated GitHub's squash commit's title and body should be manually replaced by PR's title and description; that includes both manual merges and auto-merges.
   Do not leave original commit messages in the squashed commit body.

## Calls "to show and/or to explain"

Please multiply the knowledge shared on calls and 1-1 messages by writing a separate detailed blog-post article (not in the project's source code).
1-1s are good to check what you might have missed along the way - what seemed to you obvious and to others is not.
